/**********************************************/
/* OLION QgKΉϊvO           */
/**********************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	int		c,num,add;
	int		hflag;

	if (argc != 3) {
		fprintf(stderr, "Usage: olion2tg infile outfile\n");
		exit(1);
	}

/* file open */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	hflag = 0;
	num = 0;
	while ((c = fgetc(infp)) != EOF) {
		if (hflag < 10) {
			if (c == 0xd3) {
				hflag ++;
			} else {
				hflag = 0;
			}
			fputc(c,outfp);
		} else {
			add = num + 0x8400 - 5;
			switch (add) {
				case 0x97b2 : fputc(0xd5,outfp); break;
				case 0x97b3 : fputc(0x07,outfp); break;
				case 0x97b4 : fputc(0x57,outfp); break;
				case 0x97b5 : fputc(0xe6,outfp); break;
				case 0x97b6 : fputc(0x10,outfp); break;
				case 0x97b7 : fputc(0x47,outfp); break;
				case 0x97b8 : fputc(0x7a + 1,outfp); break;
				case 0x97b9 : fputc(0x07,outfp); break;
				case 0x97ba : fputc(0x57,outfp); break;
				case 0x97bb : fputc(0xe6,outfp); break;
				case 0x97bc : fputc(0x0c,outfp); break;
				case 0x97bd : fputc(0xb0,outfp); break;
				case 0x97be : fputc(0x47,outfp); break;
				case 0x97bf : fputc(0x7a,outfp); break;
				case 0x97c0 : fputc(0x07 + 1,outfp); break;
				case 0x97c1 : fputc(0xe6,outfp); break;
				case 0x97c2 : fputc(0xa1,outfp); break;
				case 0x97c3 : fputc(0xb0,outfp); break;
				case 0x97c4 : fputc(0xd1,outfp); break;
				case 0x97c5 : fputc(0xc9,outfp); break;
				default : fputc(c,outfp); break;
			}
			num ++;
		}
	}


	fclose(infp);
	fclose(outfp);

	return(0);
}
